Subject: bug#50424: 27.2; Tab bar button mouse face not clearing entirely

From: Alan Third <[email-masked]>
Date: Wed, 8 Sep 2021 17:57:50 +0100

On Wed, Sep 08, 2021 at 09:05:50AM +0300, Eli Zaretskii wrote:
> > Date: Wed, 8 Sep 2021 00:13:15 +0100
> > From: Alan Third <[email-masked]>
> > Cc: Po Lu <[email-masked]>, Juri Linkov <[email-masked]>,
> > 	[email-masked]
> > 
> > On Tue, Sep 07, 2021 at 01:41:38PM +0300, Eli Zaretskii wrote:
> > > 
> > > I hope the information here will allow Juri and people who really
> > > understand the meaning of an image margin and relief (Alan?) fix the
> > > rest of the problem.
> > 
> > AFAIK the margin and relief are entirely handled by the term code and
> > don't really have anything to do with the image itself. I expect
> > that's why this is an OS specific problem.
> 
> The code to deal with that is identical in xterm.c and w32term.c.
> 
> Can you perhaps help us understand the purpose and semantics of the
> delicate dance in the xdisp.c code I posted regarding images on the
> tool-bar buttons?  AFAIU, the xterm/w32term code was written to
> reflect that, and the tab-bar code is simply a copy of the tool-bar
> code, except that the image spec is defined entirely in Lisp, instead
> of being dynamically redefined on the fly by the C code in the display
> engine.  So we need to understand the meaning of the margins and the
> relief settings and their relation to the button being "selected" as
> well as to the value of auto-raise-tool-bar-buttons, in order to do in
> Lisp the same thing.  Because xterm/w32term rely on this logic to
> clear the area when the mouse pointer moves off the button.

I think all it's doing is ensuring the total area the image takes up
is the same whether there's a relief or not.

The total width = image + relief width + margin width, so if you
reduce the size of the relief you have to increase the size of the
margin by the same amount to make sure it takes up the same amount of
space and doesn't move.

As far as I can see, what's happening here is that the margin is
pushing the relief one pixel into the separator to the left, so I
suspect that's why it's not being cleared.

I'm somewhat surprised that it's not pushing the right hand side one
pixel too far in the other direction and causing it to not be cleared
either, but maybe that's just chance.

The change below fixes it here, but I've not made sure it does the
right thing with different sized margins and so on.

modified   src/w32term.c
@@ -2057,11 +2057,11 @@ w32_draw_image_relief (struct glyph_string *s)
 	  && FIXNUMP (XCAR (Vtab_bar_button_margin))
 	  && FIXNUMP (XCDR (Vtab_bar_button_margin)))
 	{
-	  extra_x = XFIXNUM (XCAR (Vtab_bar_button_margin));
-	  extra_y = XFIXNUM (XCDR (Vtab_bar_button_margin));
+	  extra_x = XFIXNUM (XCAR (Vtab_bar_button_margin)) - thick;
+	  extra_y = XFIXNUM (XCDR (Vtab_bar_button_margin)) - thick;
 	}
       else if (FIXNUMP (Vtab_bar_button_margin))
-	extra_x = extra_y = XFIXNUM (Vtab_bar_button_margin);
+	extra_x = extra_y = XFIXNUM (Vtab_bar_button_margin) - thick;
     }
 
   if (s->face->id == TOOL_BAR_FACE_ID)
modified   src/xterm.c
@@ -3235,11 +3235,11 @@ x_draw_image_relief (struct glyph_string *s)
 	  && FIXNUMP (XCAR (Vtab_bar_button_margin))
 	  && FIXNUMP (XCDR (Vtab_bar_button_margin)))
 	{
-	  extra_x = XFIXNUM (XCAR (Vtab_bar_button_margin));
-	  extra_y = XFIXNUM (XCDR (Vtab_bar_button_margin));
+	  extra_x = XFIXNUM (XCAR (Vtab_bar_button_margin)) - thick;
+	  extra_y = XFIXNUM (XCDR (Vtab_bar_button_margin)) - thick;
 	}
       else if (FIXNUMP (Vtab_bar_button_margin))
-	extra_x = extra_y = XFIXNUM (Vtab_bar_button_margin);
+	extra_x = extra_y = XFIXNUM (Vtab_bar_button_margin) - thick;
     }
 
   if (s->face->id == TOOL_BAR_FACE_ID)

-- 
Alan Third